
#include "arm_math.h" 
 
#define TEST_LENGTH_SAMPLES 2048
 
/* ------------------------------------------------------------------- 
* External Input and Output buffer Declarations for FFT Bin Example 
* ------------------------------------------------------------------- */ 
extern float32_t testInput_f32_10khz[TEST_LENGTH_SAMPLES]; 
static float32_t testOutput[TEST_LENGTH_SAMPLES/2]; 
 
/* ------------------------------------------------------------------ 
* Global variables for FFT Bin Example 
* ------------------------------------------------------------------- */ 
uint32_t fftSize = 1024;
uint32_t ifftFlag = 0; 
uint32_t doBitReverse = 1; 
 
 
/* ---------------------------------------------------------------------- 
* Max magnitude FFT Bin test 
* ------------------------------------------------------------------- */ 
 
uint32_t mainFFT(void)
{ 
   
	arm_cfft_radix4_instance_f32 S; 

	/* Initialize the CFFT/CIFFT module */  
	arm_cfft_radix4_init_f32(&S, fftSize,
	  								ifftFlag, doBitReverse); 
	 
	/* Process the data through the CFFT/CIFFT module */ 
	arm_cfft_radix4_f32(&S, testInput_f32_10khz); 
	 
	 
	/* Process the data through the Complex Magnitude Module for  
	calculating the magnitude at each bin */ 
	arm_cmplx_mag_f32(testInput_f32_10khz, testOutput,  
	  				fftSize);  
	 
	/* Calculates maxValue and returns corresponding BIN value */ 
	uint32_t maxIndex = 0;
	float32_t maxValue = 0.0f;
	arm_max_f32(testOutput, fftSize, &maxValue, &maxIndex);
	return maxIndex;
}
